django/django_project/dashboard/urls.py
from django.urls import path
from dashboard import views


urlpatterns = [
    # Register and Login
    path('register/', views.register_user, name='register_user'),
    path('login/', views.login_user, name='login_user'),
    path('logout/', views.logout_user, name='logout_user'),
    path('confirm-registr/', views.confirm_registr, name='confirm_registr'),
    path('activate/<uidb64>/<token>', views.activate, name='activate'),

    # User Operations
    path('update_user/<str:pk>/', views.update_user, name='update_user'),

    # Dashboard app
    path('dash/<str:pk>/', views.user_dashboard, name='user_dashboard'),
    path('user_projects/<str:pk>/', views.user_projects, name='user_projects'),
    path('project_create/<str:pk>/', views.project_create, name='project_create'),
    path('task_create/', views.task_create, name='task_create'),
    path('projects/', views.all_projects, name='projects'),
    path('project_details/<str:pk>/', views.project_details, name='project_details'),
    path('task_details/<str:pk>/', views.task_details, name='task_details'),

    # Delete
    path('delete/<str:pk>/<str:object>', views.delete, name='delete')
]

django/django_project/django_project/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

from dashboard import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('dashboard/', include('dashboard.urls')),
    path('', views.user_dashboard, name='user_dashboard')
] + (
    static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
)

django/django_project/dashboard/models.py
from django.db import models
from django.contrib.auth.models import User
from django.utils import timezone


class Project(models.Model):
    STATUS_CHOICES = (
        ("PG", "Pending"),
        ("IP", "In progress"),
        ("CM", "Completed"),
        ("BH", "Behind"),
    )
    name = models.CharField(max_length=100)
    description = models.TextField()
    start_date = models.DateField()
    due_date = models.DateField()
    owner = models.ForeignKey(
        User, on_delete=models.CASCADE, related_name='owned_projects')
    collaborators = models.ManyToManyField(
        User, related_name='collaborating_projects')
    status = models.CharField(
        max_length=20, choices=STATUS_CHOICES, default="PG")

    def __str__(self):
        return self.name


class Task(models.Model):
    STATUS_CHOICES = (
        ("YS", "Yet to start"),
        ("IP", "In progress"),
        ("IR", "In review"),
        ("FN", "Finished"),
    )

    name = models.CharField(max_length=100)
    description = models.TextField()
    start_date = models.DateTimeField()
    due_date = models.DateTimeField()
    status = models.CharField(
        max_length=20, choices=STATUS_CHOICES, default="YS")
    assigned_to = models.ForeignKey(
        User, on_delete=models.CASCADE, related_name='user_tasks')
    project = models.ForeignKey(
        Project, on_delete=models.CASCADE, related_name='tasks', null=True)
    timestamp = models.DateTimeField(auto_now=True)
    last_status_change = models.DateTimeField(null=True, editable=False)
    time_spent = models.DurationField(null=True, blank=True)

    def __str__(self):
        return self.name

    @property
    def productivity(self):
        total_tasks = Task.objects.filter(assigned_to=self.assigned_to).count()
        completed_tasks = Task.objects.filter(
            assigned_to=self.assigned_to, status="FN").count()

        if total_tasks > 0:
            productivity = round((completed_tasks / total_tasks) * 100, 2)
        else:
            productivity = 0

        return productivity

    def save(self, *args, **kwargs):
        # Update the last_status_change field when STATUS is changed to "FN"
        if self.status == "FN":
            self.last_status_change = timezone.now()
        super().save(*args, **kwargs)


class Sprint(models.Model):
    name = models.CharField(max_length=255, null=True, blank=True)
    project = models.ForeignKey(
        Project, on_delete=models.CASCADE, related_name='project_sprint')
    task = models.ManyToManyField(Task, related_name='task_sprint')
    start_sprint = models.DateTimeField()
    end_sprint = models.DateTimeField()

    @property
    def productivity(self):
        completed_tasks = self.task.filter(status="FN").count()
        if self.task.count() > 0:
            productivity = (completed_tasks / self.task.count()) * 100
        else:
            productivity = 0

        return productivity

django/django_project/dashboard/views.py
import json

from django.shortcuts import render, redirect
from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.decorators import login_required
from django.contrib.auth.tokens import default_token_generator
from django.contrib import messages
from django.utils.http import urlsafe_base64_decode
from django.utils.encoding import force_str
from django.db.models import Q
from django.contrib.auth.models import User

from dashboard import forms, models, tasks
from dashboard.utils import time_until_due


def register_user(request):
    if request.user.is_authenticated:
        return redirect('user_dashboard', pk=request.user.id)
    else:
        if request.method == 'POST':
            form = forms.CustomUserCreationForm(data=request.POST)
            if form.is_valid():
                # 'commit=False' means user is created in memory and not yet
                # in database
                user = form.save(commit=False)
                user.is_active = False
                form.save()

                # Send the email with the confirmation link
                tasks.send_email(request, user, form.cleaned_data.get('email'))

                request.session['current_user'] = {'email': user.email}
                return redirect('confirm_registr')
            else:
                context = {
                    'form': form,
                    'page_title': 'Registration',
                    'footer_register': 'registr_login/registration_footer.html'
                }
                return render(
                    request, 'registr_login/registration.html', context)

        form = forms.CustomUserCreationForm
        context = {
            'form': form,
            'page_title': 'Registration',
            'footer_register': 'registr_login/registration_footer.html'
        }
        return render(request, 'registr_login/registration.html', context)


def activate(request, uidb64, token):
    try:
        uid = force_str(urlsafe_base64_decode(uidb64))
        user = User.objects.get(pk=uid)
    except (TypeError, ValueError, OverflowError, User.DoesNotExist):
        user = None

    if user is not None and default_token_generator.check_token(user, token):
        user.is_active = True
        user.save()
        return redirect('login_user')
    else:
        messages.error(request, 'Invalid activation link.')
        # TODO Failed Activation page
        # return redirect('activation_failed')


def confirm_registr(request):
    context = {
        'page_title': 'Confirm Registration',
        'footer_login': 'registr_login/login_footer.html'
    }
    return render(request, 'registr_login/confirm_registration.html', context)


def login_user(request):
    if request.user.is_authenticated:
        return redirect('user_dashboard', pk=request.user.id)
    else:
        if request.method == 'POST':
            username = request.POST.get('username')
            password = request.POST.get('password')

            user = authenticate(request, username=username, password=password)

            if user is not None:
                login(request, user)
                return redirect('user_dashboard', pk=user.id)
            else:
                messages.info(request, 'Username or password is incorrect')

        context = {
            'page_title': 'Login',
            'footer_register': 'registr_login/login_footer.html'
        }
        return render(request, 'registr_login/login.html', context)


def logout_user(request):
    logout(request)
    return redirect('login_user')


@login_required(login_url='login_user')
def update_user(request, pk):
    user = models.User.objects.get(id=request.user.pk)

    if request.method == 'POST':
        user_form = forms.CustomUserChangeForm(request.POST, instance=user)

        if user_form.is_valid():
            user_form.save()
            context = {
                'page_title': 'Update Info',
                'user_form': user_form
            }
            return render(request, 'update_user.html', context)

    user_form = forms.CustomUserChangeForm(instance=user)
    context = {
        'page_title': 'Update Info',
        'user_form': user_form
    }
    return render(request, 'update_user.html', context)


@login_required(login_url='login_user')
def user_dashboard(request, pk='4'):
    current_user = request.user
    tasks = models.Task.objects.filter(assigned_to=current_user)
    if tasks:
        productivity = tasks[0].productivity
    else:
        productivity = 0

    # Compare the URL parameter with the currently logged-in user's identifier
    if current_user.pk != int(pk):
        pk = current_user.pk
        return redirect('user_dashboard', pk=pk)

    # Retrieve all projects associated with the user
    owned_projects_count = models.Project.objects.filter(
        owner=current_user).count()
    collab_projects_count = models.Project.objects.filter(
        collaborators=current_user).exclude(owner=current_user).count()

    # Retrieve all tasks associated with the user
    tasks_count = models.Task.objects.filter(assigned_to=current_user).count()

    # Queryset to retrieve all other collaborators
    user = User.objects.get(id=current_user.id)

    collaborators_count = User.objects.filter(
        Q(collaborating_projects__in=user.owned_projects.all()) |
        Q(owned_projects__collaborators=user)
    ).exclude(id=user.id).distinct().count()

    work_count = {
        'owned_projects_count': owned_projects_count,
        'collab_projects_count': collab_projects_count,
        'tasks_count': tasks_count,
        'collaborators_count': collaborators_count,
    }

    # Retrieve statuses - Projects
    done_project_count = models.Project.objects.filter(
        Q(owner=current_user) | Q(collaborators=current_user), status="CM"
    ).distinct().count()
    in_p_project_count = models.Project.objects.filter(
        Q(owner=current_user) | Q(collaborators=current_user), status="IP"
    ).distinct().count()
    behind_project_count = models.Project.objects.filter(
        Q(owner=current_user) | Q(collaborators=current_user), status="BH"
    ).distinct().count()

    total_projects = models.Project.objects.filter(Q(owner=current_user) | Q(
        collaborators=current_user)).distinct().count()
    if total_projects == 0 or done_project_count == 0:
        done_project_percent = 0
    else:
        done_project_percent = (done_project_count / total_projects) * 100

    if total_projects == 0 or in_p_project_count == 0:
        in_p_project_percent = 0
    else:
        in_p_project_percent = (in_p_project_count / total_projects) * 100

    if total_projects == 0 or behind_project_count == 0:
        behind_project_percent = 0
    else:
        behind_project_percent = (behind_project_count / total_projects) * 100

    # Retrieve statuses - Tasks
    done_task_count = models.Task.objects.filter(
        assigned_to=current_user, status="FN").count()
    recently_updated_tasks = models.Task.objects.filter(
        assigned_to=current_user).order_by('-last_status_change')[:5]

    due_times = {
        str(task): time_until_due(task) for task in recently_updated_tasks}

    sprint_queryset = models.Sprint.objects.order_by('-start_sprint')[:10]

    sprint_list = []
    for sprint in sprint_queryset:
        sprint_list.append([sprint.name, sprint.productivity])
    sprint_json = json.dumps(sprint_list)

    status_overview = {
        'done_task_count': done_task_count,
        'done_project_percent': round(done_project_percent),
        'in_p_project_percent': round(in_p_project_percent),
        'behind_project_percent': round(behind_project_percent),
        'recently_updated_tasks': recently_updated_tasks,
        'due_times': due_times,
    }
    context = {
        'page_title': 'Dashboard',
        'work_count': work_count,
        'status_overview': status_overview,
        'productivity': productivity,
        'sprint_json': sprint_json,
    }
    return render(request, 'dashboard.html', context)


@login_required(login_url='login_user')
def user_projects(request, pk):
    # Compare the URL parameter with the currently logged-in user's identifier
    if request.user.pk != int(pk):
        pk = request.user.pk
        return redirect('user_projects', pk=pk)

    user_projects = models.Project.objects.filter(
        Q(owner=request.user.pk) | Q(collaborators=request.user.pk)).distinct()

    context = {
        'page_title': 'Projects',
        'user_projects': user_projects,
    }
    return render(request, 'user_projects.html', context)


@login_required(login_url='login_user')
def project_create(request, pk):
    # Compare the URL parameter with the currently logged-in user's identifier
    if request.user.pk != int(pk):
        pk = request.user.pk
        return redirect('user_projects', pk=pk)

    if request.method == 'POST':
        form = forms.ProjectCreateForm(request.POST)
        if form.is_valid():
            form.save()
            context = {'page_title': 'Projects', 'form': form}
            return render(request, 'project_create.html', context)

    form = forms.ProjectCreateForm
    context = {'page_title': 'Projects', 'form': form}
    return render(request, 'project_create.html', context)


@login_required(login_url='login_user')
def task_create(request):
    if request.method == 'POST':
        form = forms.TaskCreateForm(request.POST)
        if form.is_valid():
            form.save()
            context = {'page_title': 'Projects', 'form': form}
            return render(request, 'task_create.html', context)

    form = forms.TaskCreateForm
    context = {'page_title': 'Projects', 'form': form}
    return render(request, 'task_create.html', context)


@login_required(login_url='login_user')
def all_projects(request):
    all_projects = models.Project.objects.extra(
        select={'status_order': "status = 'IP'"},
        order_by=['-status_order', 'status']
    )

django/django_project/templates/create_person.html
{% extends 'main.html' %}

{% load static %}

{% block content %}

<!-- start page title -->
<div class="row">
    <div class="col-12">
        <div class="page-title-box">
            <div class="page-title-right">
                <ol class="breadcrumb m-0">
                    <li class="breadcrumb-item"><a href="javascript: void(0);">Hyper</a></li>
                    <li class="breadcrumb-item"><a href="javascript: void(0);">Forms</a></li>
                    <li class="breadcrumb-item active">Form Validation</li>
                </ol>
            </div>
            <h4 class="page-title">Dodaj</h4>
        </div>
    </div>
</div>
<!-- end page title -->

<div class="row">
    <div class="col-12">
        <div class="card">
            <div class="card-body">
                <div class="tab-content">
                    <div class="row">
                        <div class="col-lg-6">

                            <!-- Form Start -->
                            <form action="" method="post" class="">
                                {% csrf_token %}
                                <div class="mb-3">
                                    <label class="form-label" for="validationCustom01">Ime i prezime</label>
                                    {{ person_form.full_name }}
                                    <div class="valid-feedback">
                                        Looks good!
                                    </div>
                                </div>
                                <div class="mb-3 pt-1">
                                    <label class="form-label" for="validationCustom02">Mjesto</label>
                                    {{ person_form.city }}
                                    <div class="valid-feedback">
                                        Looks good!
                                    </div>
                                </div>
                                <div class="mb-3 pt-1">
                                    <label class="form-label" for="validationCustom04">Poštanski broj</label>
                                    {{ person_form.postal_code }}
                                    <div class="invalid-feedback">
                                        Please provide a valid state.
                                    </div>
                                </div>
                                <div class="mb-3 pt-1">
                                    <label class="form-label" for="validationCustom05">Ulica i broj</label>
                                    {{ person_form.street_name }}
                                    <div class="invalid-feedback">
                                        Please provide a valid zip.
                                    </div>
                                </div>
                                <div class="mb-3 pt-1">
                                    <label class="form-label" for="validationCustom03">Broj telefona</label>
                                    {{ phone_form.phone_number }}
                                    <div class="invalid-feedback">
                                        Please provide a valid city.
                                    </div>
                                </div>
                                <button class="btn btn-primary mt-2" type="submit">Submit form</button>
                            </form>
                        </div> <!-- end col-lg-6-->
                            <!-- Form End -->
                    </div>
                </div> <!-- end tab-content-->
            </div> <!-- end card-body-->
        </div> <!-- end card-->
    </div> <!-- end col-->
</div>
<!-- end row -->


<!-- bundle -->
<script src="{% static 'js/vendor.min.js' %}"></script>
<script src="{% static 'js/app.min.js' %}"></script>


{% endblock %}

django/django_project/templates/delete.html
{% extends 'main.html' %}

{% load static %}

{% block content %}

<!-- start page title -->
<div class="row">
    <div class="col-12">
        <div class="page-title-box">
            <h4 class="page-title">Delete</h4>
        </div>
    </div>
</div>
<!-- end page title -->

<div class="row">
    <div class="col-12">
        <div class="card">
            <div class="card-body">
                <div class="tab-content">
                    <div class="row">
                        <div class="col-lg-6">
                            <p>Are you sure you want to delete:</p>
                            <p>- {{ delete_object.name }}</p>
                            <!-- Form Start -->
                            <form action="" method="post" class="">
                                {% csrf_token %}
                                <a href="#" onclick="history.back()" class="btn btn-danger mb-2"><i class="dripicons-cross me-2"></i>Cancel</a>

                                <button class="btn btn-success mb-2 mx-3" type="submit"><i class="dripicons-checkmark me-2"></i>Ok, Delete</button>
                            </form>
                        </div> <!-- end col-lg-6-->
                            <!-- Form End -->
                    </div>
                </div> <!-- end tab-content-->
            </div> <!-- end card-body-->
        </div> <!-- end card-->
    </div> <!-- end col-->
</div>
<!-- end row -->


<!-- bundle -->
<script src="{% static 'js/vendor.min.js' %}"></script>
<script src="{% static 'js/app.min.js' %}"></script>


{% endblock %}

django/django_project/templates/footer.html
{% load static %}

<!-- Footer Start -->
<footer class="footer">
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-6">
                <script>document.write(new Date().getFullYear())</script> © Hyper - Coderthemes.com
            </div>
            <div class="col-md-6">
                <div class="text-md-end footer-links d-none d-md-block">
                    <a href="javascript: void(0);">About</a>
                    <a href="javascript: void(0);">Support</a>
                    <a href="javascript: void(0);">Contact Us</a>
                </div>
            </div>
        </div>
    </div>
</footer>
<!-- end Footer -->

django/django_project/templates/project_details.html
{% extends 'main.html' %}

{% load static %}

{% block content %}

<!-- start page title -->
<div class="row">
    <div class="col-12">
        <div class="page-title-box">
            <div class="page-title-right">
                <ol class="breadcrumb m-0">
                    <li class="breadcrumb-item"><a href="javascript: void(0);">Hyper</a></li>
                    <li class="breadcrumb-item"><a href="javascript: void(0);">Forms</a></li>
                    <li class="breadcrumb-item active">Form Validation</li>
                </ol>
            </div>
            <h4 class="page-title">Project details</h4>
        </div>
    </div>
</div>
<!-- end page title -->

<div class="row mb-2">
    <div class="col-sm-4">
        <a href="{% url 'task_create' %}" class="btn btn-danger rounded-pill mb-3"><i class="mdi mdi-plus"></i> Create Task</a>
    </div>
</div> 
<!-- end row-->

<div class="row">
    <div class="col-12">
        <div class="card">
            <div class="card-body">
                <div class="tab-content">
                    <div class="row">
                        <div class="col-12">

                            <!-- Form Start -->
                            <form action="" method="post" class="">
                                {% csrf_token %}
                                <div class="mb-3">
                                    <label class="form-label" for="{{ form.name.id_for_label }}">Project Name</label>
                                    {{ form.name }}
                                    <div class="valid-feedback">
                                        Looks good!
                                    </div>
                                </div>
                                <div class="mb-3 pt-1">
                                    <label class="form-label" for="{{ form.description.id_for_label }}">Description</label>
                                    {{ form.description }}
                                    <div class="valid-feedback">
                                        Looks good!
                                    </div>
                                </div>
                                <div class="mb-3 pt-1">
                                    <label class="form-label" for="{{ form.start_date.id_for_label }}">Start Date</label>
                                    <input type="date" class="form-control" id="{{ form.start_date.id_for_label }}" name="{{ form.start_date.html_name }}" value="{{ form.start_date.value }}">
                                    <div class="invalid-feedback">
                                        Please provide a valid state.
                                    </div>
                                </div>
                                <div class="mb-3 pt-1">
                                    <label class="form-label" for="{{ form.due_date.id_for_label }}">Due Date</label>
                                    <input type="date" class="form-control" id="{{ form.due_date.id_for_label }}" name="{{ form.due_date.html_name }}" value="{{ form.due_date.value }}">
                                    <div class="invalid-feedback">
                                        Please provide a valid zip.
                                    </div>
                                </div>
                                <div class="mb-3 pt-1">
                                    <label class="form-label" for="{{ form.owner.id_for_label }}">Project Owner</label>
                                    {{ form.owner }}
                                    <div class="invalid-feedback">
                                        Please provide a valid city.
                                    </div>
                                </div>
                                <div class="mb-3 pt-1">
                                    <label class="form-label" for="{{ form.collaborators.id_for_label }}">Collaborators</label>
                                    {{ form.collaborators }}
                                    <div class="invalid-feedback">
                                        Please provide a valid city.
                                    </div>
                                </div>
                                <div class="mb-3 pt-1">
                                    <label class="form-label" for="{{ form.status.id_for_label }}">Status</label>
                                    {{ form.status }}
                                    <div class="invalid-feedback">
                                        Please provide a valid city.
                                    </div>
                                </div>
                                <button class="btn btn-primary mt-2" type="submit">Submit form</button>
                            </form>
                        </div> <!-- end col-lg-6-->
                        <!-- Form End -->
                        {% for task in tasks %}
                            <div class="col-lg-6 col-xxl-3">
                                <!-- task card -->
                                <div class="card d-block">
                                    <div class="card-body">
                                        <div class="dropdown card-widgets">
                                            <a href="#" class="dropdown-toggle arrow-none" data-bs-toggle="dropdown" aria-expanded="false">
                                                <i class="dripicons-dots-3"></i>
                                            </a>
                                            <div class="dropdown-menu dropdown-menu-end">
                                                <!-- item-->
                                                <a href="" class="dropdown-item"><i class="mdi mdi-pencil me-1"></i>Edit</a>
                                                <!-- item-->
                                                <a href="javascript:void(0);" class="dropdown-item"><i class="mdi mdi-delete me-1"></i>Delete</a>
                                                <!-- item-->
                                                <!-- <a href="javascript:void(0);" class="dropdown-item"><i class="mdi mdi-email-outline me-1"></i>Invite</a> -->
                                                <!-- item-->
                                                <!-- <a href="javascript:void(0);" class="dropdown-item"><i class="mdi mdi-exit-to-app me-1"></i>Leave</a> -->
                                            </div>
                                        </div>
                                        <!-- project title-->
                                        <h4 class="mt-0">
                                            <a href="" class="text-title">{{ task.name }}</a>
                                        </h4>
                                        <!--  -->
                                        <!--  -->
                                        {% if task.status == 'PG' %}
                                            <div class="badge bg-info">{{ task.get_status_display }}</div>
                                        {% elif task.status == 'IP' %}
                                            <div class="badge bg-primary">{{ task.get_status_display }}</div>
                                        {% elif task.status == 'BH' %}
                                            <div class="badge bg-danger">{{ task.get_status_display }}</div>
                                        {% else %}
                                            <div class="badge bg-success">{{ task.get_status_display }}</div>
                                        {% endif %}
                                        <!--  -->
                                        <!--  -->
                                        <p class="text-muted font-13 my-3">{{ task.description }}...<a href="javascript:void(0);" class="fw-bold text-muted"> view more</a>
                                        </p>
                    
                                        <!-- project detail-->
                                        <div id="tooltip-container">
                                            <!-- <a href="javascript:void(0);" data-bs-container="#tooltip-container" data-bs-toggle="tooltip" data-bs-placement="top" title="Mat Helme" class="d-inline-block">
                                                <img src="assets/images/users/avatar-6.jpg" class="rounded-circle avatar-xs" alt="friend">
                                            </a>
                    
                                            <a href="javascript:void(0);" data-bs-container="#tooltip-container" data-bs-toggle="tooltip" data-bs-placement="top" title="Michael Zenaty" class="d-inline-block">
                                                <img src="assets/images/users/avatar-7.jpg" class="rounded-circle avatar-xs" alt="friend">
                                            </a>
                    
                                            <a href="javascript:void(0);" data-bs-container="#tooltip-container" data-bs-toggle="tooltip" data-bs-placement="top" title="James Anderson" class="d-inline-block">
                                                <img src="assets/images/users/avatar-8.jpg" class="rounded-circle avatar-xs" alt="friend">
                                            </a> -->
                                        </div>
                                    </div> <!-- end card-body-->
                                    <ul class="list-group list-group-flush">
                                        <li class="list-group-item p-3">
                                            <!-- project progress-->
                                            <p class="mb-2 fw-bold">Progress <span class="float-end">{{ task.time_spent }}%</span></p>
                                            <div class="progress progress-sm">
                                                <div class="progress-bar" role="progressbar" aria-valuenow="100" aria-valuemin="0" aria-valuemax="100" style="width: 100%;">
                                                </div><!-- /.progress-bar -->
                                            </div><!-- /.progress -->
                                        </li>
                                    </ul>
                                </div> <!-- end card-->
                            </div> <!-- end col -->
                        {% endfor %}
                    </div>
                </div> <!-- end tab-content-->
            </div> <!-- end card-body-->
        </div> <!-- end card-->
    </div> <!-- end col-->
</div>
<!-- end row -->


<!-- bundle -->
<script src="{% static 'js/vendor.min.js' %}"></script>
<script src="{% static 'js/app.min.js' %}"></script>


{% endblock %}